﻿"use strict";

//namespace
var ToDo = window.ToDo || {};

//app definition
ToDo.App = angular.module('todoApp', ['ngRoute']);

//route definitions
ToDo.App.config(["$routeProvider",
    function ($routeProvider) {
        $routeProvider.when("/", {
            controller: 'homeCtrl',
            templateUrl: 'views/home.html'
        }).when("/view/:id", {
            controller: 'viewCtrl',
            templateUrl: 'views/view.html'
        }).when("/edit/:id", {
            controller: 'editCtrl',
            templateUrl: 'views/edit.html'
        }).when("/new", {
            controller: 'newCtrl',
            templateUrl: 'views/new.html'
        }).otherwise({
            redirectTo: "/"
        });
    }]);

